
    include "tios.h"
    include "util.h"                 
    include "graphlib.h"

    xdef _main
    xdef _comment
    xdef _ti89

DrawFrame MACRO
    move.w  \1,d0      ;x
    move.w  \2,d1      ;y
    move.w  \3,d4      ;width
    move.w  \4,d5      ;height
    jsr     graphlib::frame
    ENDM

DrawVert MACRO          
    move.w  \1,d0       ;x-pos
    move.w  \2,d1       ;y1-pos
    move.w  \3,d2       ;y2-pos
    jsr     graphlib::vert
    ENDM

DrawHoriz MACRO
    move.w  \1,d1       ;y-pos
    move.w  \2,d0       ;x1-pos
    move.w  \3,d2       ;x2-pos
    move.w  \4,d3       ;the color 
    jsr     graphlib::frame
    ENDM

DrawRect MACRO
    move.w  \1,d0
    move.w  \2,d1
    move.w  \3,d2
    move.w  \4,d3
    move.w  \5,d4
    jsr     graphlib::fill
    ENDM

WriteStr MACRO
    move.w  \3,-(a7)
    pea \4(pc)
    move.w  \2,-(a7)
    move.w  \1,-(a7)
    jsr     tios::DrawStrXY
    lea     10(a7),a7
    ENDM

print_d0 MACRO
    lea     strend(PC),a0
    move.w  #3,d1
    bsr     ConvStr
    move.w  \3,-(a7)
    move.l  a0,-(a7)
    move.w  \2,-(a7)
    move.w  \1,-(a7)
    jsr     tios::DrawStrXY
    lea     10(a7),a7
    ENDM
SetFont MACRO
    move.w  \1,-(a7)
    jsr     tios::FontSetSys       ; set the font
    add.l   #2,a7                  ; clean up the stack
    ENDM    
;***************************************START
_main:


;***************************************VARIABLE INIT
ini_vars:
    move.w #1,counter
    move.b  #0,xtemp
    move.w  #19,pre
    move.w  #0,temp1
    move.w  #99,x
    move.w  #25,y
    move.w  #0,len
    move.w  #5,wid
    move.w  #0,e
    move.w  #0,m
    move.w  #0,d
    cmp #0,month
    bne calendar
    move.w  #2,month
calendar:
    move.w  #61,xpos
    move.w  #26,ypos
    move.w  #40,p1y
    move.w  #40,p2y
    move.w  #0,escflag
    move.w  #0,p1score
    move.w  #0,p2score
    move.w  #1000,delay_len
    move.w  #0,b1x
    move.w  #0,b1y
    move.w  #0,b2x
    move.w  #180,b2y
;***************************************TITLE SCREEN
title_scr:
    jsr     graphlib::clr_scr2
    SetFont #0
    WriteStr #50,#35,#1,author
    WriteStr #30,#45,#1,email
    WriteStr #45,#60,#1,version
    SetFont #1
    WriteStr #30,#80,#1,year
tit2
    SetFont #2
    tst.w    (tios::kb_vars+$1c)          
    bne    tit3                 
tit4
    WriteStr b2y,#15,#3,title
    cmp #0,b2y
    beq next
    sub.w   #1,b2y
    bra     tit2
tit3:
   move.w #0,b2y
   bra tit4
next:
    bsr get_year
    cmp.w   #264,d0
    beq     escape
    cmp.w   #13,d0
    beq     prog_loop2
    bra     next
repeat
    jsr     util::idle_loop
    jsr     graphlib::clr_scr2
    
    cmp     #264,d0
    bne     prog_loop2
    bsr     escape    
escape:
    move.w  #1,escflag
    rts
prog_loop2:
    SetFont #1
    bsr get_month
    SetFont #2
    jsr     util::clr_scr
    WriteStr #0,#15,#0,days
    move pre,d0
    print_d0   #115,#0,#1
    move.w #0,d0
    move x,d0
    print_d0   #131,#0,#1
    move.w x,d0
    cmp.w #10,d0
    bcs patch2
    bra goon2
patch2:
    move.w #0,d0
    print_d0    #123,#0,#1       ;PRESTO
goon2:
    SetFont #0
    WriteStr #0,#95,#0,_comment
prog_loop:
    Bsr    leap
    bsr    monthy
    bsr    addup
    bsr    drawcal
    jsr  util::idle_loop


    rts

get_year
    DrawRect #91,#77,#35,#8,#1
    move.w  pre,d0
    print_d0   #83,#77,#1
    move.w  x,d0
    cmp.w #10,d0
    bcs patch
    bra goon
patch:
    move.w #0,d0
    print_d0    #91,#77,#1
goon:
    move.w x,d0
    print_d0    #99,#77,#1
    jsr     util::idle_loop
    cmp     #338,d0
    beq     minus
    cmp     #344,d0
    beq     add
    rts
add:
    add.w   #1,x
    cmp     #100,x
    bne     get_year
    sub.w   #100,x
    add.w  #1,pre
    move.w #1,temp1
    bra     get_year
minus:
    sub.w   #1,x
    cmp     #-1,x
    bne get_year
    add.w   #100,x
    sub.w   #1,pre
    move.w  #0,temp1
    bra     get_year
get_month
    DrawRect #30,#75,#95,#12,#1
    move.w  month,d0
    print_d0   #86,#79,#1
    WriteStr #57,#79,#1,monthget
    jsr  util::idle_loop
    cmp  #338,d0
    beq sub_month
    cmp  #344,d0
    beq add_month
    rts
sub_month:

    cmp #1,month
    beq get_month
    sub #1,month

    bra get_month
add_month:
    cmp #12,month
    beq get_month

    add #1,month
    bra get_month



leap:
    move  #0,y
    move   x,d0
    ;jsr graphlib::clr_scr
    ;print_d0   #83,#77,#1
    ;jsr util::idle_loop
    move x,d0
    divu.w   #4,d0
    move.b   d0,xtemp
    bra    compare
compare:
    cmp.l    y,d0
    beq    return
    add.l    #1,y
    cmp.l    #26,y
    beq    done
    bra compare
return:
    move   #1,wid
    rts
done:
     rts
monthy:
     bsr check
     rts
check:
     move #1,e
     SetFont #2
     cmp #1,month
     beq jan
     cmp #2,month
     beq feb
     cmp #3,month
     beq mar
     cmp #4,month
     beq apr
     cmp #5,month
     beq may
     cmp #6,month
     beq jun
     cmp #7,month
     beq jul
     cmp #8,month
     beq aug
     cmp #9,month
     beq sep
     cmp #10,month
     beq oct
     cmp #11,month
     beq nov
     cmp #12,month
     beq dec
     rts
     
jan:
    WriteStr #0,#0,#1,jan1
    move     #1,d
    move     #31,m
    bsr janleap
    rts
janleap:
    cmp #1,wid
    beq janleap2
    rts
janleap2
    move     #0,d
    rts
feb:
    WriteStr #0,#0,#1,feb2
    move     #4,d
    move     #28,m
    bsr febleap
    rts
febleap:
    cmp #1,wid
    beq febleap2
    rts
febleap2
    move     #3,d
    move     #29,m
    rts



mar:
    WriteStr #0,#0,#1,mar3
    move     #4,d
    move     #31,m
    
    rts
apr:
    WriteStr #0,#0,#1,apr4
    move     #0,d
    move     #30,m
   
    rts
may:
    WriteStr #0,#0,#1,may5
    move     #2,d
    move     #31,m
    
    rts
jun:
    WriteStr #0,#0,#1,jun6
    move     #5,d
    move     #30,m
    
    rts
jul:
    WriteStr #0,#0,#1,jul7
    move     #0,d
    move     #31,m
   
    rts
aug:
    WriteStr #0,#0,#1,aug8
    move     #3,d
    move     #31,m
   
    rts
sep:
    WriteStr #0,#0,#1,sep9
    move     #6,d
    move     #30,m
    
    rts
oct:
    WriteStr #0,#0,#1,oct10
    move     #1,d
    move     #31,m
    
    rts
nov:
    WriteStr #0,#0,#1,nov11
    move     #4,d
    move     #30,m
    
    rts
dec:
    WriteStr #0,#0,#1,dec12
    move     #6,d
    move     #31,m
    
    rts
addup
    clr.l d0
    move.b xtemp,d1
    move.w x,d2 
    add.w d2,d1
    add.w #1,d1
    add.w d,d1
    move.w d1,d2

    divu #7,d1
    ;;;;;
    cmp  #20,pre
    bne  go_on
    sub #1,d2

go_on
    ;;;;;;;;;;;;;;;;;;;;;;;;;
    move.w d1,d0
    mulu #7,d0
    sub.w d0,d2
    move.w d2,d0
    move.w d2,d1
    mulu #24,d0
    sub  #24,d0
    move d0,xpos
    ;;print_d0    #99,#77,#1
    rts
drawcal:
    SetFont #1

    move.w #30,ypos
    mulu.l #24,d1
    move.w d1,xpos
    cmp.w #0,xpos
    blt saturday
    bra drawing
saturday:
    move.w #144,d1
    move.w d1,xpos
drawing:
    move.w #1,d1
    bsr drawing2
    rts
drawing2:
    move.w counter,d0
    move xpos,d3
    sub  #7,xpos
    print_d0   xpos,ypos,#1
    move d3,xpos
    move.w counter,d0
    cmp m,d0
    beq done
    add #1,d1
    add.w #1,counter
    add.w #24,xpos
    cmp.w #168,xpos
    beq new_row
    bra drawing2
new_row:
    move.w #0,xpos
    add.w #9,ypos
    bra drawing 2



;*******************************CONVERT D0 TO A STRING
ConvStr:
    movem.l d0-d2,-(a7)
    clr.b   (a0)
conv_repeat:
    divu    #10,d0
    move.l  d0,d2
    swap    d2
    add.b   #48,d2
    move.b  d2,-(a0)
    subq    #1,d1
    and.l   #$FFFF,d0
    bne     conv_repeat
    tst.w   d1
    beq     conv_done
    subq    #1,d1
fillout:
    move.b  #32,-(a0)
    dbra    d1,fillout
conv_done:
    movem.l (a7)+,d0-d2
    rts

str             ds.b 16
strend
keystat         ds.b 7
keyscan         dc.w 0,0,0,0,0

counter         dc.w 0
xtemp           dc.b 0
pre             dc.w 0
temp1           dc.w 0
x               dc.w 0
y               dc.w 0
len             dc.w 0
wid             dc.w 0
e               dc.w 0
m               dc.w 0
d               dc.w 0
month           dc.w 0
xpos            dc.w 0
ypos            dc.w 0
p1y             dc.w 0
p2y             dc.w 0

p1score         dc.w 0
p2score         dc.w 0

escflag         dc.w 0
delay_len       dc.w 0

b1x             dc.w 0
b1y             dc.w 0
b2x             dc.w 0
b2y             dc.w 0

title          dc.b " * SUPER CALENDAR * ",0
author          dc.b "by: Preston Clark",0
email          dc.b "email- DClark9899@aol.com",0
version         dc.b "Version 1.0, 1/07/99",0
year            dc.b "Year? (",17,18,")______",0
_comment        dc.b "Presto Calendar by Preston Clark",0
days            dc.b "S  M  T  W  T  F  S  ",0
monthget          dc.b "Month:",0
jan1            dc.b "January",0
feb2            dc.b "February",0
mar3            dc.b "March",0
apr4            dc.b "April",0
may5            dc.b "May",0
jun6            dc.b "June",0
jul7            dc.b "July",0
aug8            dc.b "August",0
sep9            dc.b "September",0
oct10           dc.b "October",0
nov11           dc.b "November",0
dec12           dc.b "December",0











    end
